class SpotifyService():
    def __init__(self, access_code):
        print(f'Hello I am a Spotify object builder with {access_code}')

class SpotifyServiceBuilder:
    def __init__(self):
        self._instance = None

    def __call__(self, spotify_client_key, spotify_client_secret, **_ignored):
        if not self._instance:
            access_code = self.authorize(
                spotify_client_key, spotify_client_secret)
            self._instance = SpotifyService(access_code)
        return self._instance

    def authorize(self, key, secret):
        return 'Hello Paradigms!'

class ObjectFactory:
    def __init__(self):
        self._builders = {}

    def register_builder(self, key, builder):
        self._builders[key] = builder

    def create(self, key, **kwargs):
        builder = self._builders.get(key)
        if not builder:
            raise ValueError(key)
        return builder(**kwargs)

factory = ObjectFactory()
factory.register_builder('SPOTIFY', SpotifyServiceBuilder())

arg_dict = {'spotify_client_key': 'Hello', 'spotify_client_secret': 'Paradigms'}

factory.create('SPOTIFY', **arg_dict)